CLS
FOR c% = 1 TO 24    ' display text on the screen
  COLOR (c% - 1)
  FOR d% = 1 TO 80
    COLOR ,(d% MOD 16)
    PRINT "*";
  NEXT d%
NEXT c%

DIM Regis%(0:15)    ' save the initial colors
DIM Settings?(0:15, 0:2), Orig?(0:15, 0:2)
FOR c% = 0 TO 15
  Regis%(c%) = WhichRegister%(c%)
  CALL ReadDACRegister(Regis%(c%), Red?, Green?, Blue?)
  Settings?(c%, 0) = Red?
  Settings?(c%, 1) = Green?
  Settings?(c%, 2) = Blue?
  Orig?(c%, 0) = Red?
  Orig?(c%, 1) = Green?
  Orig?(c%, 2) = Blue?
NEXT c%

' fade the screen
%Increment = 4      ' # of steps to fade with each iteration
FOR c% = 0 TO 63 STEP %Increment ' go through all possible values
  FOR d% = 0 TO 15  ' go through each DAC register
    FOR e% = 0 TO 2
      IF Settings?(d%, e%) <= %Increment THEN
        Settings?(d%, e%) = 0
      ELSE
        DECR Settings?(d%, e%), %Increment
      END IF
    NEXT e%
    CALL SetDACRegister(Regis%(d%), Settings?(d%, 0), Settings?(d%, 1), Settings?(d%, 2))
  NEXT d%
  ASM nop
NEXT c%

SOUND 400,2
WHILE LEN(INKEY$) = 0 : WEND

' restore original settings
FOR c% = 0 TO 15
  CALL SetDACRegister(Regis%(c%), Orig?(c%, 0), Orig?(c%, 1), Orig?(c%, 2))
NEXT c%
END
